SystemOrganization addCategory: #OLE!

!Symbol methodsFor: '*ole' stamp: 'lg 10/1/2007 17:19'!
value: x
	^x perform: self.! !

!RipoffPatch methodsFor: '*ole' stamp: 'lg 9/24/2007 17:54'!
setTarget: morph
	target := morph.
	self position: morph position; extent: morph extent.! !

RectangleMorph subclass: #NumberGame
	instanceVariableNames: 'minValue maxSum'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!NumberGame class methodsFor: 'game' stamp: 'lg 10/1/2007 16:29'!
answer: n 
	World allMorphsDo: [ :m | (m isKindOf: self) ifTrue: [m answer: n]].
! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/1/2007 16:32'!
answer: n
	n = self getGameValue ifTrue: [self beep: 'clink'. self newGame]
								 ifFalse: [self beep: 'horn'].
! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/1/2007 15:30'!
gameInputs
	^World allMorphs select: #isGameInput.! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/1/2007 16:34'!
getGameValue
	^(self gameInputs collect: #getGameValue) sum.! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/1/2007 16:17'!
increaseInputs
	| seed |
	seed := (0 to: maxSum - (minValue * self gameInputs size)) atRandom.
	seed timesRepeat: [ self gameInputs atRandom increment ].
! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/1/2007 17:18'!
initialize
	super initialize.
	minValue := 1.
	maxSum := 9.! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/1/2007 16:14'!
newGame
	self resetInputs; increaseInputs.
! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/1/2007 16:15'!
resetInputs
	self gameInputs do: [ :input | input setGameValue: minValue ].
! !

!Morph methodsFor: '*ole-menus' stamp: 'lg 9/25/2007 11:31'!
addStandardHaloMenuItemsTo: aMenu hand: aHandMorph
	"Add standard halo items to the menu"

	| unlockables |

	self isWorldMorph ifTrue:
		[^ self addWorldHaloMenuItemsTo: aMenu hand: aHandMorph].

	self mustBeBackmost ifFalse:
		[aMenu add: 'send to back' translated action: #goBehind.
		aMenu add: 'bring to front' translated action: #comeToFront.
		self addEmbeddingMenuItemsTo: aMenu hand: aHandMorph.
		aMenu add: 'rip off' translated action: #ripoff.
		aMenu addLine].

	self addFillStyleMenuItems: aMenu hand: aHandMorph.
	self addBorderStyleMenuItems: aMenu hand: aHandMorph.
	self addDropShadowMenuItems: aMenu hand: aHandMorph.
	self addLayoutMenuItems: aMenu hand: aHandMorph.
	Preferences eToyFriendly ifFalse: [self addHaloActionsTo: aMenu].
	owner isTextMorph ifTrue:[self addTextAnchorMenuItems: aMenu hand: aHandMorph].
	aMenu addLine.
	self addToggleItemsToHaloMenu: aMenu.
	aMenu addLine.
	Preferences eToyFriendly ifFalse: [self addCopyItemsTo: aMenu].
	self addPlayerItemsTo: aMenu.
	Preferences eToyFriendly ifFalse: [self addExportMenuItems: aMenu hand: aHandMorph].
	Preferences eToyFriendly ifFalse: [self addStackItemsTo: aMenu].
	self addMiscExtrasTo: aMenu.
	Preferences eToyFriendly ifFalse: [Preferences noviceMode ifFalse:
		[self addDebuggingItemsTo: aMenu hand: aHandMorph]].

	aMenu addLine.
	aMenu defaultTarget: self.

	aMenu addLine.

	unlockables _ self submorphs select:
		[:m | m isLocked].
	unlockables size == 1 ifTrue:
		[aMenu
			add: ('unlock "{1}"' translated format: {unlockables first externalName})
			action: #unlockContents].
	unlockables size > 1 ifTrue:
		[aMenu add: 'unlock all contents' translated action: #unlockContents.
		aMenu add: 'unlock...' translated action: #unlockOneSubpart].

	aMenu defaultTarget: aHandMorph.
! !

!Morph methodsFor: '*ole' stamp: 'lg 9/25/2007 10:20'!
exchangeWith: morph 
	morph position: self position; extent: self extent.
	owner replaceSubmorph: self by: morph.! !

!Morph methodsFor: '*ole' stamp: 'lg 10/1/2007 15:19'!
isGameInput
	^false! !

!Morph methodsFor: '*ole' stamp: 'lg 9/24/2007 17:00'!
ripOff
	| m |
	m := RipoffPatchMorph new initialize setTarget: self.
	owner addMorph: m after: self.
	owner removeMorph: self.
	self position: World activeHand position.
	World activeHand grabMorph: self.
! !

!Morph methodsFor: '*ole' stamp: 'lg 9/25/2007 11:23'!
ripoff
   | morph patch |
	morph := RippedOffMorph new setTarget: self.
	patch := RipoffPatchMorph new setTarget: morph.
	morph setPatch: patch.
	self exchangeWith: patch.
	morph position: World activeHand center.
	World activeHand grabMorph: morph.
! !

!DigitChooserMorph methodsFor: '*ole' stamp: 'lg 9/21/2007 13:37'!
addButtonRows
	| row |
	#( (1 2 3) (4 5 6) (7 8 9) ) do:
		[ :digits |
			row := AlignmentMorph newRow vResizing: #spaceFill; cellInset: 3; yourself.
			digits do: [ :d | row addMorphBack: (self buttonFor: d)].
			self addMorph: row]! !

!DigitChooserMorph methodsFor: '*ole' stamp: 'lg 10/1/2007 16:45'!
buttonFor: digit 
	^ SimpleButtonMorph new target: NumberGame;
		label: digit asString font: Preferences standardEToysButtonFont;
		actionSelector: #answer:;
		arguments: { digit };
		hResizing: #spaceFill;
		vResizing: #spaceFill.! !

!DigitChooserMorph methodsFor: '*ole' stamp: 'lg 9/21/2007 13:46'!
initialize
	super initialize.
	self extent: 300@300.
	self layoutPolicy: TableLayout new.
	self listDirection: #bottomToTop.
	self vResizing: #spaceFill.
	self cellInset: 3.
	self cellPositioning: #center.
	self listCentering: #justified.
	self wrapCentering: #justified.
	borderWidth := 2.
	self addButtonRows.
! !

TextMorph subclass: #GameTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!GameTextMorph methodsFor: 'game value' stamp: 'lg 10/1/2007 16:34'!
getGameValue
	^self getNumericValue.! !

!GameTextMorph methodsFor: 'game value' stamp: 'lg 10/1/2007 16:08'!
increment
	self setNumericValue: self getNumericValue + 1.! !

!GameTextMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/1/2007 15:25'!
isGameInput
	^true! !

!GameTextMorph methodsFor: 'game value' stamp: 'lg 10/1/2007 16:08'!
setGameValue: n 
	self setNumericValue: n.! !

!RippedOffMorph methodsFor: '*ole' stamp: 'lg 9/25/2007 12:07'!
replacePatch: patchMorph
	target extent: patchMorph extent; position: patchMorph position.
	patch owner replaceSubmorph: patchMorph by: target.
	OLE congratulate.! !
